﻿using UniversityContracts.BindingModels;
using UniversityContracts.BuisnessLogicContracts;
using UniversityContracts.SearchModels;
using UniversityContracts.StoragesContracts;
using UniversityContracts.ViewModels;
using Microsoft.Extensions.Logging;

namespace UniversityBuisnessLogic.BuisnessLogic
{
    public class ReportLogic : IReportLogic
    {
        ILogger _logger;
        IDisciplineStorage _disciplineStorage;

        public ReportLogic(ILogger<ReportLogic> logger, IDisciplineStorage disciplineStorage)
        {
            _logger = logger;
            _disciplineStorage = disciplineStorage;
        }

        public List<ReportStudentDisciplineViewModel> GetStudentDiscipline(ReportBindingModel model)
        {
            if (model == null || model.Students == null) return new();

            var disciplines = _disciplineStorage.GetFullList();
            List<ReportStudentDisciplineViewModel> result = new();

            foreach(var student in model.Students)
            {
                var record = new ReportStudentDisciplineViewModel
                {
                    StudentName = student.Name,
                };

                foreach(var discipline in disciplines)
                {
                    if(student.Statements.ContainsKey(discipline.Id))
                    {
                        record.Disciplines.Add(discipline.Name);
                    }
                }

                result.Add(record);
            }

            return result;
        }
    }
}
